#!/usr/bin/awk -f

# Usage : ./analyse_resum_file.awk RESUME_CALCUL_NDMIN......

BEGIN                { FS="=" ; simul="ko"}
#simul != "ok"&& $1 != ""  && $2 != "" { print $1":",$2; }
"NB_MARKER"    == $1 { nmk=$2 }
"POS_QTL"      == $1 { posqtl=$2 }
"EFF_QTL"      == $1 { effqtl=$2 }
"H2"           == $1 { h2=$2 }
"RATIO_POLQTL" == $1 { ratio_polqtl=$2 }
"NG"           == $1 { ng=$2 }
"NMPED"        == $1 { nmped=$2 }
"NFMPED"       == $1 { nfmped=$2 }
"NDFPED"       == $1 { ndfped=$2 }
"NMQTL"        == $1 { nmqtl=$2 }
"NFMQTL"       == $1 { nfmqtl=$2 }
"NDFQTL"       == $1 { ndfqtl=$2 }
"QTLMAP_H2"    == $1 { qtlmap_h2=$2 }
"QTLMAP_NSIM"  == $1 { qtlmap_nsim=$2 }

simul == "ok"  {
              nbsim++;
              id[nbsim]                   = $1
              pqtl[$1" "nbsim]            = $2;
              lrtm[$1" "nbsim]            = $3;
              flk_left[$1" "nbsim]        = $4;
              flk_right[$1" "nbsim]       = $5;
              thres0_10000[$1" "nbsim]    = $6;
              thres0_05000[$1" "nbsim]    = $7;
              thres0_00100[$1" "nbsim]    = $8;
              thres0_00050[$1" "nbsim]    = $9;
              thres0_00027[$1" "nbsim]    = $10;
              thres0_00001[$1" "nbsim]    = $11;
}

" == SIMUL == " == $0 { FS=" ";}
"GROUPE_SEED" == $1 { simul="ok"; nbsim=0;}

END {  
       # Calcul % de detection 
       t1=0;t2=0;t3=0;t4=0;t5=0;t6=0
       for (i=1;i<=nbsim;i++) {
         groupeseed=id[i];
         if ( lrtm[groupeseed" "i] > thres0_00001[groupeseed" "i] ) {
           t6++;sign[i]=1;continue;
         }
         if ( lrtm[groupeseed" "i] > thres0_00027[groupeseed" "i] ) {
           t5++;sign[i]=1;continue;
         }
         if ( lrtm[groupeseed" "i] > thres0_00050[groupeseed" "i] ) {
           t4++;sign[i]=1;continue;
         }
         if ( lrtm[groupeseed" "i] > thres0_00100[groupeseed" "i] ) {
           t3++;sign[i]=1;continue;
         }
         if ( lrtm[groupeseed" "i] > thres0_05000[groupeseed" "i] ) {
           t2++;sign[i]=1;continue;
         }
         if ( lrtm[groupeseed" "i] > thres0_10000[groupeseed" "i] ) {
           t1++;sign[i]=1;continue;
         }
         sign[i]=0; # la position estimee n'est pas significative
       }      
 # nb>0.1 nb>0.05 ...   total lrt significatif
 #print "LRT Significatif (>0.1) (>0.05) (>0.01) (>0.005) (>0.0027) (>0.0001) (TOTAL)"
 printf("t1=%i\nt2=%i\nt3=%i\nt4=%i\nt5=%i\nt6=%i\ntotal=%i\n",t1,t2,t3,t4,t5,t6,(t1+t2+t3+t4+t5+t6));

     mseGeneral=0.0;
     mseSignificatif=0.0;
     nbsimsign=0;

     for (i=1;i<=nbsim;i++) {
       v=(posqtl - pqtl[id[i]" "i]);
       d=int(v*100);#distance en cM pour un histogramme
       #d<0?d=-d:d=d;
       v=v*v;
       mseGeneral = mseGeneral + v;
       if ( sign[i] == 1 ) {
         mseSignificatif = mseSignificatif + v;
         nbsimsign++;
         #if (! d in histo) histo[d]=0;
         histo[d]=histo[d]+1;
       }
     }
     mseGeneral = mseGeneral / nbsim ;
     if ( nbsimsign > 0 ) {
      mseSignificatif = mseSignificatif / nbsimsign ;
     }

 #print "Precision MSE pour toute les positions :"
 printf("mseg=%f\n",mseGeneral);
 #print "Precision MSE pour toute les positions significatives :"
 printf("mse=%f\n",mseSignificatif);

 print "===== samples.dat ======"
 for (i=-100;i<=100;i++) {
   if ( i in histo ) {
     printf("%i ",histo[i]);
   } else {
    printf("%i ",0);
   }
 }
 print "\n===== end ======"

 printf("nbsim=%i\n",nbsim);
 print ""
}
