#!/bin/bash

# 

RESUMFILE=`basename $1`
PWWD=`dirname $1`
ROOT=`dirname $0`
$ROOT/analyse_resum_file.awk $1 > temp.$$

cat temp.$$

NMK=`cat $1 | awk ' BEGIN {FS="="} "NB_MARKER"  == $1 { print $2 }'`
POSQTL=`cat $1 | awk ' BEGIN {FS="="} "POS_QTL" == $1 { print $2 }'`
EFF_QTL=`cat $1 | awk ' BEGIN {FS="="} "EFF_QTL"  == $1 { print $2 }'`
H2=`cat $1 | awk ' BEGIN {FS="="} "H2" == $1 { print $2 }'`
RATIO_POLQTL=`cat $1 | awk ' BEGIN {FS="="} "RATIO_POLQTL"  == $1 { print $2 }'`
NG=`cat $1 | awk ' BEGIN {FS="="} "NG" == $1 { print $2 }'`
NMPED=`cat $1 | awk ' BEGIN {FS="="} "NMPED"  == $1 { print $2 }'`
NFMPED=`cat $1 | awk ' BEGIN {FS="="} "NFMPED" == $1 { print $2 }'`
NDFPED=`cat $1 | awk ' BEGIN {FS="="} "NDFPED"  == $1 { print $2 }'`
NMQTL=`cat $1 | awk ' BEGIN {FS="="} "NMQTL" == $1 { print $2 }'`
NFMQTL=`cat $1 | awk ' BEGIN {FS="="} "NFMQTL"  == $1 { print $2 }'`
NDFQTL=`cat $1 | awk ' BEGIN {FS="="} "NDFQTL" == $1 { print $2 }'`
QTLMAP_H2=`cat $1 | awk ' BEGIN {FS="="} "QTLMAP_H2"  == $1 { print $2 }'`
QTLMAP_NSIM=`cat $1 | awk ' BEGIN {FS="="} "QTLMAP_NSIM" == $1 { print $2 }'`

T1=`cat temp.$$ | awk ' BEGIN {FS="="} "t1" == $1 { print $2 }'`
T2=`cat temp.$$ | awk ' BEGIN {FS="="} "t2" == $1 { print $2 }'`
T3=`cat temp.$$ | awk ' BEGIN {FS="="} "t3" == $1 { print $2 }'`
T4=`cat temp.$$ | awk ' BEGIN {FS="="} "t4" == $1 { print $2 }'`
T5=`cat temp.$$ | awk ' BEGIN {FS="="} "t5" == $1 { print $2 }'`
T6=`cat temp.$$ | awk ' BEGIN {FS="="} "t6" == $1 { print $2 }'`
TOTAL=`cat temp.$$ | awk ' BEGIN {FS="="} "total" == $1 { print $2 }'`

MSEG=`cat temp.$$ | awk ' BEGIN {FS="="} "mseg" == $1 { print $2 }'`
MSE=`cat temp.$$ | awk ' BEGIN {FS="="} "mse" == $1 { print $2 }'`
NBSIM=`cat temp.$$ | awk ' BEGIN {FS="="} "nbsim" == $1 { print $2 }'`

cat temp.$$ | awk 'BEGIN {ok="n";} $0=="===== end ======" {ok="n"} ok=="y" { ii=-100;for (i=1;i<=NF;i++) {ii++;print ii" "$i}} $0 == "===== samples.dat ======" {ok="y";}' > sample$$.data

nbd1=`cat sample$$.data | awk '$1 == -1 {print $2}'`
nbd2=`cat sample$$.data | awk '$1 == 0 {print $2}'`
nbd3=`cat sample$$.data | awk '$1 == 1 {print $2}'`
sumnbd=$(( $nbd1 + $nbd2 + $nbd3 ))

sumnbd2=`cat sample$$.data | awk '$1 == -2 {print $2}'`
sumnbd2=$(( $sumnbd2 + `cat sample$$.data | awk '$1 == 2 {print $2}'`))
sumnbd2=$(( $sumnbd + $sumnbd2 )) 

sumnbd3=`cat sample$$.data | awk '$1 == -3 {print $2}'`
sumnbd3=$(( $sumnbd3 + `cat sample$$.data | awk '$1 == 3 {print $2}'`))
sumnbd3=$(( $sumnbd2 + $sumnbd3 ))

persumnbd=`awk 'BEGIN { print (( '$sumnbd' / '$NBSIM')*100) }'`
persumnbd2=`awk 'BEGIN { print (('$sumnbd2' / '$NBSIM')*100) }'`
persumnbd3=`awk 'BEGIN { print (('$sumnbd3' / '$NBSIM')*100) }'`

mkdir -p RAPPORT

gnuplot <<EOF
set title "Ecart à la position réelle du qtl - $RESUMFILE (nbsim=$NBSIM)";
set term png size 1600,1200;
set output "RAPPORT/$RESUMFILE.png";
set ylabel "NbSimul";
set xlabel "cMorgan";
set xrange [-80:80];
#set yrange [0:110];
set style fill solid border -1;
set label sprintf("nmk=%i",$NMK) at 30,50;
set label sprintf("posiqtl=%1.3f",$POSQTL) at 30,51;
set label sprintf("effqtl=%1.3f",$EFF_QTL) at 30,52;
set label sprintf("h2=%1.3f",$H2) at 30,53;
set label sprintf("ratiopolqtl=%1.3f",$RATIO_POLQTL) at 30,54;
set label sprintf("ng=%i",$NG) at 30,55;
set label sprintf("nmped=%i",$NMPED) at 30,56;
set label sprintf("nfmped=%i",$NFMPED) at 30,57;
set label sprintf("ndfped=%i",$NDFPED) at 30,58;
set label sprintf("nmqtl=%i",$NMQTL) at 30,59;
set label sprintf("nfmqtl=%i",$NFMQTL) at 30,60;
set label sprintf("ndfqtl=%i",$NDFQTL) at 30,61;
set label sprintf("qtlmaph2=%1.3f",$QTLMAP_H2) at 30,62;
set label sprintf("nsimqtlmap=%i",$QTLMAP_NSIM) at 30,63;


set label sprintf("LRT Significatif (>0.1000)=%i",$T1) at 30,48;
set label sprintf("LRT Significatif (>0.0500)=%i",$T2) at 30,47;
set label sprintf("LRT Significatif (>0.0100)=%i",$T3) at 30,46;
set label sprintf("LRT Significatif (>0.0050)=%i",$T4) at 30,45;
set label sprintf("LRT Significatif (>0.0027)=%i",$T5) at 30,44;
set label sprintf("LRT Significatif (>0.0001)=%i",$T6) at 30,43;
set label sprintf("LRT Significatif (TOTAL)=%i",$TOTAL) at 30,42;

set label sprintf("MSE ($NBSIM simul) =%f",$MSEG) at 30,40;
set label sprintf("MSE Significatif ($TOTAL simul)=%f",$MSE) at 30,39;


set label sprintf("-0,01 cMorgan from true position = %i",$nbd1) at 30,26;
set label sprintf("true position                    = %i",$nbd2) at 30,27;
set label sprintf("+0,01 cMorgan from true position = %i",$nbd3) at 30,25;
set label sprintf("+-0.01 from the true position = %i (%2.1f\%)",$sumnbd,$persumnbd) at 30,23;
set label sprintf("+-0.02 from the true position = %i (%2.1f\%)",$sumnbd2,$persumnbd2) at 30,22;
set label sprintf("+-0.03 from the true position = %i (%2.1f\%)",$sumnbd3,$persumnbd3) at 30,21;


# Dessin de la courbe
plot 'sample$$.data' with boxes title 'Histogramme';
EOF

rm sample$$.data
rm temp.$$

